diff --git a/src/main/java/net/minecraft/core/block/PumiceBlock.java b/src/main/java/net/minecraft/core/block/PumiceBlock.java
index e19cb0ada..a000bcddb 100644
--- a/src/main/java/net/minecraft/core/block/PumiceBlock.java
+++ b/src/main/java/net/minecraft/core/block/PumiceBlock.java
@@ -22,7 +22,7 @@ public class PumiceBlock extends Block {
     {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte radius = 2;
-        if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.paradise.id)){
+        if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.PARADISE.id)){
             world.setBlockWithNotify(x, y, z, Blocks.PUMICE_DRY.id);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
diff --git a/src/main/java/net/minecraft/core/block/RailBlock.java b/src/main/java/net/minecraft/core/block/RailBlock.java
index d0749b316..5e5e56937 100644
--- a/src/main/java/net/minecraft/core/block/RailBlock.java
+++ b/src/main/java/net/minecraft/core/block/RailBlock.java
@@ -228,7 +228,7 @@ public class RailBlock extends Block {
     }
 
     @Override
-    public int getPistonPushReaction()
+    public int getPistonPushReaction(World world, int x, int y, int z)
     {
         return 0;
     }
diff --git a/src/main/java/net/minecraft/core/block/SpongeBlock.java b/src/main/java/net/minecraft/core/block/SpongeBlock.java
index f583b79b5..fd6f03993 100644
--- a/src/main/java/net/minecraft/core/block/SpongeBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpongeBlock.java
@@ -27,7 +27,7 @@ public class SpongeBlock extends Block
     {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte byte0 = 2;
-        if(world.dimension.id == Dimension.nether.id && isWet){
+        if(world.dimension.id == Dimension.NETHER.id && isWet){
             world.setBlockWithNotify(x, y, z, Blocks.SPONGE_DRY.id);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
diff --git a/src/main/java/net/minecraft/core/block/SteelFenceBlock.java b/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
new file mode 100644
index 000000000..2f554c0a6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.WorldSource;
+
+public class SteelFenceBlock extends ThinFenceBlock {
+    public SteelFenceBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
+    }
+
+    @Override
+    public boolean canConnectTo(WorldSource world, int x, int y, int z) {
+        int id = world.getBlockId(x, y, z);
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial == Material.stone || Block.blocksList[id].blockMaterial == Material.metal));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/ThinFenceBlock.java b/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
index 7eb18be65..9252fc551 100644
--- a/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
@@ -57,7 +58,45 @@ public abstract class ThinFenceBlock extends Block
         return false;
     }
 
-    public abstract boolean canConnectTo(WorldSource iblockaccess, int x, int y, int z);
+    public abstract boolean canConnectTo(WorldSource world, int x, int y, int z);
 
-    public abstract boolean shouldDrawColumn(WorldSource iblockaccess, int x, int y, int z);
+    public boolean shouldDrawColumn(WorldSource world, int x, int y, int z) {
+        boolean drawColumn = shouldDrawColumn_do(world, x, y, z);
+        if (drawColumn) return true;
+
+        int oy = 1;
+        while (world.getBlockId(x, y + oy, z) == this.id)
+        {
+            oy++;
+        }
+        oy--;
+
+        boolean drawColumnFromOther = false;
+        while (world.getBlockId(x, y + oy, z) == this.id)
+        {
+            if (shouldDrawColumn_do(world, x, y + oy, z))
+            {
+                drawColumnFromOther = true;
+                break;
+            }
+            oy--;
+        }
+
+        return drawColumnFromOther;
+    }
+
+    private boolean shouldDrawColumn_do(WorldSource world, int x, int y, int z)
+    {
+        boolean connectNorth = canConnectTo(world, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
+        boolean connectSouth = canConnectTo(world, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
+        boolean connectEast = canConnectTo(world, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
+        boolean connectWest = canConnectTo(world, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
+
+        boolean lineNorthSouth = connectNorth && connectSouth;
+        boolean lineEastWest = connectEast && connectWest;
+
+        return (!lineNorthSouth && !lineEastWest) || (lineNorthSouth && lineEastWest) ||
+            (lineNorthSouth && (connectEast || connectWest)) ||
+            (lineEastWest && (connectNorth || connectSouth));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/material/Material.java b/src/main/java/net/minecraft/core/block/material/Material.java
index 6d2253f0b..38333208f 100644
--- a/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/src/main/java/net/minecraft/core/block/material/Material.java
@@ -2,6 +2,10 @@ package net.minecraft.core.block.material;
 
 public class Material
 {
+    public static final int PISTON_PUSHABLE = 0;
+    public static final int PISTON_DESTROY_ON_PUSH = 1;
+    public static final int PISTON_CANT_PUSH = 2;
+
     public static final int LIGHTNING_NEUTRAL = 0;
     public static final int LIGHTNING_STRONG_CONDUCTOR = 20;
     public static final int LIGHTNING_LIGHT_CONDUCTOR = 5;
@@ -12,7 +16,7 @@ public class Material
     private boolean notSolidBlocking;
     public final MaterialColor color;
     private boolean alwaysDestroyable;
-    private int pushReaction;
+    private int pushReaction = PISTON_PUSHABLE;
     private int lightningConductivity = LIGHTNING_NEUTRAL;
 
     public Material(MaterialColor color)
@@ -99,13 +103,13 @@ public class Material
 
     public Material destroyOnPush()
     {
-        pushReaction = 1;
+        pushReaction = PISTON_DESTROY_ON_PUSH;
         return this;
     }
 
     public Material notPushable()
     {
-        pushReaction = 2;
+        pushReaction = PISTON_CANT_PUSH;
         return this;
     }
     public int getConductivity(){
@@ -153,7 +157,7 @@ public class Material
     public static final Material portal = new PortalMaterial(MaterialColor.none).notPushable();
     public static final Material cake = new Material(MaterialColor.none).destroyOnPush();
     public static final Material web = new Material(MaterialColor.wool).notAlwaysDestroyable().destroyOnPush();
-    public static final Material piston = new Material(MaterialColor.stone).notPushable();
+    public static final Material piston = new Material(MaterialColor.stone);
     public static final Material moss = new Material(MaterialColor.grass).flammable().notAlwaysDestroyable();
     public static final Material woodWet = (new Material(MaterialColor.grass).setConductivity(LIGHTNING_LIGHT_CONDUCTOR));
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
index a21b97e82..51c42e8e0 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
@@ -6,21 +6,16 @@ import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-
-// Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, World, TileEntityPiston,
-//            Block, PistonBlockTextures, AxisAlignedBB, IBlockAccess,
-//            BlockEntity, Player
+import org.jetbrains.annotations.Nullable;
 
 public class MovingPistonBlock extends EntityBlock
 {
-
     public MovingPistonBlock(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.piston);
@@ -41,10 +36,10 @@ public class MovingPistonBlock extends EntityBlock
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        BlockEntity tileentity = world.getBlockEntity(x, y, z);
-        if(tileentity != null && (tileentity instanceof MovingPistonBlockEntity))
+        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+        if((blockEntity instanceof MovingPistonBlockEntity))
         {
-            ((MovingPistonBlockEntity)tileentity).finalTick();
+            ((MovingPistonBlockEntity)blockEntity).finalTick();
         } else
         {
             super.onBlockRemoved(world, x, y, z, data);
@@ -120,9 +115,10 @@ public class MovingPistonBlock extends EntityBlock
         }
     }
 
-    public static BlockEntity createTileEntity(int id, int oldData, int newData, boolean flag, boolean flag1)
+    public static BlockEntity createTileEntity(int movedId, int movedData, @Nullable BlockEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
     {
-        return new MovingPistonBlockEntity(id, oldData, newData, flag, flag1);
+        assert !(movedEntity instanceof MovingPistonBlockEntity) : "Moving piston entity should not be able to be put into another moving piston!";
+        return new MovingPistonBlockEntity(movedId, movedData, movedEntity, direction, extending, isSourcePiston);
     }
 
     @Override
@@ -144,49 +140,49 @@ public class MovingPistonBlock extends EntityBlock
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        MovingPistonBlockEntity tileentitypiston = getBlockEntity(world, x, y, z);
-        if(tileentitypiston != null)
+        MovingPistonBlockEntity pistonBlockEntity = getBlockEntity(world, x, y, z);
+        if(pistonBlockEntity != null)
         {
-            Block block = Block.blocksList[tileentitypiston.getMovedId()];
+            Block block = Block.blocksList[pistonBlockEntity.getMovedId()];
             if(block == null || block == this)
             {
                 return;
             }
             block.setBlockBoundsBasedOnState(world, x, y, z);
-            float f = tileentitypiston.getProgress(0.0F);
-            if(tileentitypiston.isExtending())
+            float f = pistonBlockEntity.getProgress(0.0F);
+            if(pistonBlockEntity.isExtending())
             {
                 f = 1.0F - f;
             }
-            int l = tileentitypiston.getDirection();
-            minX = block.minX - (double)((float) PistonDirections.xOffset[l] * f);
-            minY = block.minY - (double)((float) PistonDirections.yOffset[l] * f);
-            minZ = block.minZ - (double)((float) PistonDirections.zOffset[l] * f);
-            maxX = block.maxX - (double)((float) PistonDirections.xOffset[l] * f);
-            maxY = block.maxY - (double)((float) PistonDirections.yOffset[l] * f);
-            maxZ = block.maxZ - (double)((float) PistonDirections.zOffset[l] * f);
+            Direction direction = pistonBlockEntity.getDirection();
+            minX = block.minX - direction.getOffsetX() * f;
+            maxX = block.maxX - direction.getOffsetX() * f;
+            minY = block.minY - direction.getOffsetY() * f;
+            maxY = block.maxY - direction.getOffsetY() * f;
+            minZ = block.minZ - direction.getOffsetZ() * f;
+            maxZ = block.maxZ - direction.getOffsetZ() * f;
         }
     }
 
-    public AABB getCollisionShapeFromTileEntity(WorldSource world, int x, int y, int z, int l, float f, int i1)
+    public AABB getCollisionShapeFromTileEntity(WorldSource world, int x, int y, int z, int blockID, float directionStretch, Direction direction)
     {
-        if(l == 0 || l == id)
+        if(blockID == 0 || blockID == id)
         {
             return null;
         }
-        AABB axisalignedbb = Block.blocksList[l].getCollisionBoundingBoxFromPool(world, x, y, z);
-        if(axisalignedbb == null)
+        AABB aabb = Block.blocksList[blockID].getCollisionBoundingBoxFromPool(world, x, y, z);
+        if(aabb == null)
         {
             return null;
         } else
         {
-            axisalignedbb.minX -= (float) PistonDirections.xOffset[i1] * f;
-            axisalignedbb.maxX -= (float) PistonDirections.xOffset[i1] * f;
-            axisalignedbb.minY -= (float) PistonDirections.yOffset[i1] * f;
-            axisalignedbb.maxY -= (float) PistonDirections.yOffset[i1] * f;
-            axisalignedbb.minZ -= (float) PistonDirections.zOffset[i1] * f;
-            axisalignedbb.maxZ -= (float) PistonDirections.zOffset[i1] * f;
-            return axisalignedbb;
+            aabb.minX -= direction.getOffsetX() * directionStretch;
+            aabb.maxX -= direction.getOffsetX() * directionStretch;
+            aabb.minY -= direction.getOffsetY() * directionStretch;
+            aabb.maxY -= direction.getOffsetY() * directionStretch;
+            aabb.minZ -= direction.getOffsetZ() * directionStretch;
+            aabb.maxZ -= direction.getOffsetZ() * directionStretch;
+            return aabb;
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index e9406cf4d..e1f113dd8 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -3,24 +3,38 @@ package net.minecraft.core.block.piston;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
 public class MovingPistonBlockEntity extends BlockEntity
 {
+    public static final int TICKS_TO_EXTEND = 2;
+    private static final List<Entity> entityBuffer = new ArrayList<>();
 
+    private int movedId;
+    private int movedData;
+    private @Nullable BlockEntity movedEntity;
+    private Direction direction;
+    private boolean extending;
+    private boolean isSourcePiston;
+    private float progress;
+    private float progressO;
+
+    @SuppressWarnings("unused")
     public MovingPistonBlockEntity()
     {
     }
 
-    public MovingPistonBlockEntity(int movedId, int movedData, int direction, boolean extending, boolean isSourcePiston)
+    public MovingPistonBlockEntity(int movedId, int movedData, @Nullable BlockEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
     {
         this.movedId = movedId;
         this.movedData = movedData;
+        this.movedEntity = movedEntity;
         this.direction = direction;
         this.extending = extending;
         this.isSourcePiston = isSourcePiston;
@@ -38,12 +52,16 @@ public class MovingPistonBlockEntity extends BlockEntity
         return movedData;
     }
 
+    public @Nullable BlockEntity getMovedEntity() {
+        return movedEntity;
+    }
+
     public boolean isExtending()
     {
         return extending;
     }
 
-    public int getDirection()
+    public Direction getDirection()
     {
         return direction;
     }
@@ -66,10 +84,10 @@ public class MovingPistonBlockEntity extends BlockEntity
     {
         if(extending)
         {
-            return (getProgress(partialTick) - 1.0F) * (float) PistonDirections.xOffset[direction];
+            return (getProgress(partialTick) - 1.0F) * (float) direction.getOffsetX();
         } else
         {
-            return (1.0F - getProgress(partialTick)) * (float) PistonDirections.xOffset[direction];
+            return (1.0F - getProgress(partialTick)) * (float) direction.getOffsetX();
         }
     }
 
@@ -77,10 +95,10 @@ public class MovingPistonBlockEntity extends BlockEntity
     {
         if(extending)
         {
-            return (getProgress(partialTick) - 1.0F) * (float) PistonDirections.yOffset[direction];
+            return (getProgress(partialTick) - 1.0F) * (float) direction.getOffsetY();
         } else
         {
-            return (1.0F - getProgress(partialTick)) * (float) PistonDirections.yOffset[direction];
+            return (1.0F - getProgress(partialTick)) * (float) direction.getOffsetY();
         }
     }
 
@@ -88,40 +106,34 @@ public class MovingPistonBlockEntity extends BlockEntity
     {
         if(extending)
         {
-            return (getProgress(partialTick) - 1.0F) * (float) PistonDirections.zOffset[direction];
+            return (getProgress(partialTick) - 1.0F) * (float) direction.getOffsetZ();
         } else
         {
-            return (1.0F - getProgress(partialTick)) * (float) PistonDirections.zOffset[direction];
+            return (1.0F - getProgress(partialTick)) * (float) direction.getOffsetZ();
         }
     }
 
-    private void moveCollidedEntities(float f, float f1)
+    private void moveCollidedEntities(float stretch, float force)
     {
         if(!extending)
         {
-            f--;
+            stretch--;
         } else
         {
-            f = 1.0F - f;
+            stretch = 1.0F - stretch;
         }
-        AABB axisalignedbb = ((MovingPistonBlock) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, f, direction);
-        if(axisalignedbb != null)
+        AABB aabb = ((MovingPistonBlock) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, stretch, direction);
+        if (aabb == null) return;
+
+        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
+        if(!list.isEmpty())
         {
-            List list = worldObj.getEntitiesWithinAABBExcludingEntity(null, axisalignedbb);
-            if(!list.isEmpty())
-            {
-                field_31018_m.addAll(list);
-                Entity entity = null;
-                Iterator iterator = field_31018_m.iterator();
-                do
-                {
-                    entity = (Entity)iterator.next();
-                    if (entity == null || entity.noPhysics) continue;
-                    entity.move(f1 * (float) PistonDirections.xOffset[direction], f1 * (float) PistonDirections.yOffset[direction], f1 * (float) PistonDirections.zOffset[direction]);
-                } while (iterator.hasNext());
-
-                field_31018_m.clear();
+            entityBuffer.addAll(list);
+            for (Entity entity : entityBuffer) {
+                if (entity == null || entity.noPhysics) continue;
+                entity.move(force * (float) direction.getOffsetX(), force * (float) direction.getOffsetY(), force * (float) direction.getOffsetZ());
             }
+            entityBuffer.clear();
         }
     }
 
@@ -131,7 +143,20 @@ public class MovingPistonBlockEntity extends BlockEntity
         worldObj.removeBlockTileEntity(x, y, z);
         invalidate();
         if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
-            worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
+            worldObj.setBlock(x, y, z, movedId);
+            worldObj.setBlockMetadata(x, y, z, movedData);
+            worldObj.notifyBlockChange(x, y, z, movedId);
+            if (movedEntity != null) {
+                BlockEntity oldEnt = worldObj.getBlockEntity(x, y, z);
+                if (oldEnt != null) {
+                    oldEnt.invalidate();
+                }
+                movedEntity.validate();
+                movedEntity.x = x;
+                movedEntity.y = y;
+                movedEntity.z = z;
+                worldObj.replaceBlockTileEntity(x, y, z, movedEntity);
+            }
         }
     }
 
@@ -145,8 +170,8 @@ public class MovingPistonBlockEntity extends BlockEntity
             finalTick();
             return;
         }
-        progress += 0.5F;
-        if(progress >= 1.0F)
+        progress += 1f/TICKS_TO_EXTEND;
+        if(progress >= 0.999F)
         {
             progress = 1.0F;
         }
@@ -162,7 +187,11 @@ public class MovingPistonBlockEntity extends BlockEntity
         super.readFromNBT(tag);
         movedId = tag.getInteger("blockId");
         movedData = tag.getInteger("blockData");
-        direction = tag.getInteger("facing");
+        if (tag.containsKey("blockEntity")) {
+            CompoundTag entityTag = tag.getCompound("blockEntity");
+            movedEntity = BlockEntity.createAndLoadEntity(entityTag);
+        }
+        direction = Direction.getDirectionById(tag.getInteger("facing"));
         progressO = progress = tag.getFloat("progress");
         extending = tag.getBoolean("extending");
     }
@@ -173,7 +202,12 @@ public class MovingPistonBlockEntity extends BlockEntity
         super.writeToNBT(tag);
         tag.putInt("blockId", movedId);
         tag.putInt("blockData", movedData);
-        tag.putInt("facing", direction);
+        if (movedEntity != null) {
+            CompoundTag entityTag = new CompoundTag();
+            movedEntity.writeToNBT(entityTag);
+            tag.put("blockEntity", entityTag);
+        }
+        tag.putInt("facing", direction.getId());
         tag.putFloat("progress", progressO);
         tag.putBoolean("extending", extending);
     }
@@ -182,14 +216,4 @@ public class MovingPistonBlockEntity extends BlockEntity
     public boolean canBeCarried(World world, Entity potentialHolder) {
         return false;
     }
-
-    private int movedId;
-    private int movedData;
-    private int direction;
-    private boolean extending;
-    private boolean isSourcePiston;
-    private float progress;
-    private float progressO;
-    private static List field_31018_m = new ArrayList();
-
 }
